unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    Timer: TTimer;
    Image1: TImage;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    SourBitmap1 : TBitmap;
    SourBitmap2 : TBitmap;
    DestBitmap  : TBitmap;
    MaskBitmap  : TBitmap;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
   IMAGE_SIZE_X : Integer = 510;
   IMAGE_SIZE_Y : Integer = 285;
   MASK_SIZE_X  = 80;
   MASK_SIZE_Y  = 50;

procedure TForm1.FormCreate(Sender: TObject);
var
   ImageJPEG : TJPEGImage;
begin
   SourBitmap1 := TBitmap.Create;
   SourBitmap2 := TBitmap.Create;
   DestBitmap  := TBitmap.Create;

   ImageJPEG := TJPEGImage.Create;
   ImageJPEG.Assign(Image1.Picture);
   SourBitmap1.Assign(ImageJPEG);
   SourBitmap1.PixelFormat := pf15Bit;
   ImageJPEG.Free;
   ImageJPEG := nil;

   ImageJPEG := TJPEGImage.Create;
   ImageJPEG.Assign(Image2.Picture);
   SourBitmap2.Assign(ImageJPEG);
   SourBitmap2.PixelFormat := pf15Bit;
   ImageJPEG.Free;
   ImageJPEG := nil;

   IMAGE_SIZE_X := SourBitmap1.Width;
   IMAGE_SIZE_Y := SourBitmap1.Height;

   DestBitmap.Width   := IMAGE_SIZE_X;
   DestBitmap.Height  := IMAGE_SIZE_Y;
   DestBitmap.Canvas.FillRect(Rect(0, 0, DestBitmap.Width, DestBitmap.Height));
   DestBitmap.PixelFormat := pf15Bit;

   MaskBitmap  := TBitmap.Create;
   MaskBitmap.Width  := MASK_SIZE_X;
   MaskBitmap.Height := MASK_SIZE_Y;
   MaskBitmap.Canvas.Brush.Color := RGB(0, 0, 0);
   MaskBitmap.Canvas.FillRect(Rect(0, 0, MaskBitmap.Width, MaskBitmap.Height));
   MaskBitmap.PixelFormat := pf15Bit;

   MaskBitmap.Canvas.Pen.Color := RGB(16,16,16);
   MaskBitmap.Canvas.Brush.Color := RGB(255, 255, 255);
   MaskBitmap.Canvas.Ellipse(0, 0, 50, 50);
   MaskBitmap.Canvas.Ellipse(30, 0, 80, 50);
   MaskBitmap.Canvas.Pen.Mode := pmWhite;
   MaskBitmap.Canvas.FillRect(Rect(30, 6, 50, 44));

   Width  := IMAGE_SIZE_X;
   Height := IMAGE_SIZE_Y;

   Cursor := crNone;

end;

procedure TForm1.FormShow(Sender: TObject);
begin
//
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   SourBitmap1.Free;
   SourBitmap2.Free;
   DestBitmap.Free;
end;

procedure TForm1.TimerTimer(Sender: TObject);
var
   MousePos : TPoint;
   ARect    : TRect;
   Pitch    : TPoint;
   pSour    : PWord;
   pDest    : PWord;
   pMask    : PWord;
   x, y     : Integer;
begin
   MousePos := Form1.ScreenToClient(Mouse.CursorPos);
   ARect    := Bounds(MousePos.x - MASK_SIZE_X div 2, MousePos.y - MASK_SIZE_Y div 2, MaskBitmap.Width, MaskBitmap.Height);
   Pitch    := Point(0, 0);

   if ARect.Left < 0 then begin
      Pitch.x    := Abs(ARect.Left);
      ARect.Left := 0;
   end;
   if ARect.Top < 0 then begin
      Pitch.y    := Abs(ARect.Top);
      ARect.Top  := 0;
   end;
   if ARect.Right  >= DestBitmap.Width then
      ARect.Right  := Pred(DestBitmap.Width);
   if ARect.Bottom >= DestBitmap.Height then
      ARect.Bottom := Pred(DestBitmap.Height);

   DestBitmap.Canvas.Draw(0, 0, SourBitmap1);

   for y := ARect.Top to Pred(ARect.Bottom) do begin
      pSour := SourBitmap2.ScanLine[y];
      pDest := DestBitmap.ScanLine[y];
      pMask := MaskBitmap.ScanLine[y-ARect.Top+Pitch.y];
      Inc(pSour, ARect.Left);
      Inc(pDest, ARect.Left);
      inc(pMask, Pitch.x);
      for x := ARect.Left to Pred(ARect.Right) do begin
         if pMask^ <> 0 then begin
            if pMask^ = $7FFF then begin
               pDest^ := pSour^;
            end
            else begin
               pDest^ := pMask^;
            end;
         end;
         Inc(pSour);
         Inc(pDest);
         Inc(pMask);
      end;
   end;

   Canvas.Draw(0, 0, DestBitmap);
end;

end.

